#include <LPC214x.h> //LPC 2148 definitions 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "Definitions.h"

#define ARROW_LENGTH 10
#define X_LIMIT 83
#define Y_LIMIT 5

//FrameBuffer Matrix
unsigned char framebuffer[6][84]={0};
//LCD Framebuffer
unsigned char lcdbuffer0[16] = {0};
unsigned char lcdbuffer1[16] = {0};

char read_buffer[1];//Holds value read from EEPROM

//Game Variables
int cursor;
int bank_pos;
int score;
char high_score;
int arrow_remain;
int gameOver =0;

void testHW(void);
void newBank(void);
void bow_movement(void);
void GameOver(void);
void splash(void);

void transmit(){//Transmit FrameBuffer to LCD
	int i,j;
	IOCLR0 = PCD8544_DC;			//command mode
	PCD8544_gotoXY(0,0);			
	IOSET0 = PCD8544_DC;			//data mode
	for(i=0; i<6;i++)
		for(j=0;j<84;j++)
			PCD8544_write(framebuffer[i][j]);
	//sprintf((char *)lcdbuffer0, "Score: %d        ", score);
	//lcd_putstring(0,(char *)lcdbuffer0);
}

void newBank(void){
	int i, j, width=3;
	//Generate Random position
	bank_pos = rand()%6;
	//Clear previous bank
	memset(framebuffer, 0, 84*6*sizeof(unsigned char));//Clear Screen
	//Draw Bank
	//Bank 2, Width of 3
	i = bank_pos;
	for(j= X_LIMIT - width; j <= X_LIMIT; j++)
		framebuffer[i][j] = (unsigned char)255;
	//transmit();
}

void border(){
	int i=0,j=0;
	
}

void bow_movement(){
	int i=0, j=0;
	/*for(i=0,j=0; j<=X_LIMIT; j++)
			framebuffer[i][j] = (unsigned char)1;
	//for(i=0,j=83; i<=Y_LIMIT; i++)
	//		framebuffer[i][j] = (unsigned char)255;
	for(i=5,j=83; j>=0; j--)
			framebuffer[i][j] = (unsigned char)128;
	//for(i=5,j=0; i>=0; i--)
			framebuffer[i][j] = (unsigned char)255;*/
	
	//Bow Movement
		for(cursor=0,j=0;cursor<=Y_LIMIT;cursor++){
		framebuffer[cursor][j]=(unsigned char)255;
		framebuffer[cursor][j+1]=(unsigned char)255-128-1;
		framebuffer[cursor][j+2]=(unsigned char)255-128-1-64-2;
		framebuffer[cursor][j+3]=(unsigned char)255-128-1-64-2-32-4;
		if(cursor>0){
			framebuffer[cursor-1][j]=(unsigned char)0;
			framebuffer[cursor-1][j+1]=(unsigned char)0;
			framebuffer[cursor-1][j+2]=(unsigned char)0;
			framebuffer[cursor-1][j+3]=(unsigned char)0;
		}
		//transmit();
		delayMS(125);	
		}
		for(cursor=5;cursor>=0;cursor--){
		framebuffer[cursor][j]=(unsigned char)255;
		framebuffer[cursor][j+1]=(unsigned char)255-128-1;
		framebuffer[cursor][j+2]=(unsigned char)255-128-1-64-2;
		framebuffer[cursor][j+3]=(unsigned char)255-128-1-64-2-32-4;
		if(cursor<5){
			framebuffer[cursor+1][j]=(unsigned char)0;
			framebuffer[cursor+1][j+1]=(unsigned char)0;
			framebuffer[cursor+1][j+2]=(unsigned char)0;
			framebuffer[cursor+1][j+3]=(unsigned char)0;
		}
		//transmit();
		delayMS(125);	
		}
	
}

void GameOver(){
	char disp_hs;
	//TODO Display cool graphic
	//IOCLR0 = PCD8544_DC;		//D/C low to send commands
	//PCD8544_write(PCD8544_DISPLAYCONTROL | PCD8544_DISPLAYCHECK);	//Turn ON all segments
	//sprintf((char *)lcdbuffer1, "Score:%d Max:%c  ", score, high_score);
	//lcd_putstring(1,(char *)lcdbuffer1);
	//splash();
	//delayMS(2000);
	if(score+48>high_score){
		IO1CLR |= (1<<25); 	//Start Buzzer
		delayMS(2000);		//Delay period
		IO1SET |= (1<<25); 	//Stop Buzzer
		read_buffer[0] = score+48;
		m24xx_write(EEPROM_24XX256, 0 , 0 ,(char*)read_buffer , sizeof(read_buffer));//Update value in memory
	}
	gameOver = 1;
	//Testing by reading value from memory
	m24xx_read(EEPROM_24XX256, 0 , 0 ,(char*)read_buffer , sizeof(read_buffer));//Read high score from memory
	disp_hs = read_buffer[0];
	sprintf((char *)lcdbuffer0, "Game Over!");
	lcd_putstring(0,(char *)lcdbuffer0);
	sprintf((char *)lcdbuffer1, "Score:%d Max:%c  ", score, disp_hs);
	lcd_putstring(1,(char *)lcdbuffer1);
	//Game Over MUSIC
	IO1CLR |= (1<<25); 	//Start Buzzer
	delayMS(500);		//Delay period
  IO1SET |= (1<<25); 	//Stop Buzzer
	delayMS(50);		//Delay period
	IO1CLR |= (1<<25); 	//Start Buzzer
	delayMS(400);		//Delay period
  IO1SET |= (1<<25); 	//Stop Buzzer
	delayMS(50);		//Delay period
	IO1CLR |= (1<<25); 	//Start Buzzer
	delayMS(300);		//Delay period
  IO1SET |= (1<<25); 	//Stop Buzzer
	delayMS(50);		//Delay period
	IO1CLR |= (1<<25); 	//Start Buzzer
	delayMS(200);		//Delay period
  IO1SET |= (1<<25); 	//Stop Buzzer
	delayMS(50);		//Delay period
	IO1CLR |= (1<<25); 	//Start Buzzer
	delayMS(100);		//Delay period
  IO1SET |= (1<<25); 	//Stop Buzzer
	splash();
	delayMS(2000);
	//Music ENDS
}


__irq void Ext_ISR(void)
{
	int i,j;
	//Game Code
	//Arrow Movement
	j=0;

	//Arrow Fired MUSIC
	IO1CLR |= (1<<25); 	//Start Buzzer
	delayMS(50);		//Delay period
  IO1SET |= (1<<25); 	//Stop Buzzer
	delayMS(50);		//Delay period
	IO1CLR |= (1<<25); 	//Start Buzzer
	delayMS(50);		//Delay period
  IO1SET |= (1<<25); 	//Stop Buzzer
	//Music ENDS
	
	//Arrow creation
	i=cursor;
	for(;j<ARROW_LENGTH;j++)
		framebuffer[i][j] = (unsigned char)(255-128-1-64-2-32-4);
	
	//Arrow Movement
	for(;j<=83;j++){
		framebuffer[i][j]=(unsigned char)(255-128-1-64-2-32-4-16);
		framebuffer[i][j-ARROW_LENGTH]=(unsigned char)0;
		delayMS(5);
		transmit();
	}
	
	memset(framebuffer, 0, 84*6*sizeof(unsigned char));//Clear Screen
	
	if(i==bank_pos)
		score++;
	
	arrow_remain--;
	
	sprintf((char *)lcdbuffer0, "Score: %d", score);
	lcd_putstring(0,(char *)lcdbuffer0);
	sprintf((char *)lcdbuffer1, "Arrows Left:%d  ", arrow_remain);
	lcd_putstring(1,(char *)lcdbuffer1);
	
	if(arrow_remain){
		newBank();
		bow_movement();
	}
	else
		GameOver();
	EXTINT |= 0x4; 		  //Clear interrupt for reuse
	VICVectAddr = 0; 	  //End of interrupt execution
}

__irq void Ext_ISR_Pre(void)
{
	//Beginnning Music
	IO1DIR |= (1<<25);	//Enable Buzzer
	IO1CLR |= (1<<25); 	//Start Buzzer
	delayMS(100);		//Delay period
  IO1SET |= (1<<25); 	//Stop Buzzer
	delayMS(50);		//Delay period
	IO1CLR |= (1<<25); 	//Start Buzzer
	delayMS(200);		//Delay period
  IO1SET |= (1<<25); 	//Stop Buzzer
	delayMS(50);		//Delay period
	IO1CLR |= (1<<25); 	//Start Buzzer
	delayMS(300);		//Delay period
  IO1SET |= (1<<25); 	//Stop Buzzer
	delayMS(50);		//Delay period
	IO1CLR |= (1<<25); 	//Start Buzzer
	delayMS(400);		//Delay period
  IO1SET |= (1<<25); 	//Stop Buzzer
	delayMS(50);		//Delay period
	IO1CLR |= (1<<25); 	//Start Buzzer
	delayMS(500);		//Delay period
  IO1SET |= (1<<25); 	//Stop Buzzer
	//Music ENDS
	
	//Game Initialization code
	score=0;
	bank_pos=0;
	newBank();
	arrow_remain = 5;
	m24xx_read(EEPROM_24XX256, 0 , 0 ,(char*)read_buffer , sizeof(read_buffer));//Read high score from memory
	high_score = read_buffer[0];
	sprintf((char *)lcdbuffer0, "Score: %d        ", score);
	lcd_putstring(0,(char *)lcdbuffer0);
	sprintf((char *)lcdbuffer1, "High Score: %c   ", high_score);
	lcd_putstring(1,(char *)lcdbuffer1);
	delayMS(1000);
	sprintf((char *)lcdbuffer1, "Arrows Left: %d   ", arrow_remain);
	lcd_putstring(1,(char *)lcdbuffer1);
	
	VICVectAddr5  = (unsigned int)Ext_ISR;// Button press releases arrow

	EXTINT |= 0x4; 		  //Clear interrupt for reuse
	VICVectAddr = 0; 	  //End of interrupt execution
}

__irq void Timer_ISR(){
	if((rand()%20000)<4000)
		newBank();
	if (gameOver==1)
		splash();
	transmit();
	T0IR |= 1<<0;//Clear interrupt for reuse
	VICVectAddr = 0; 	  //End of interrupt execution
}

void splash(){
	int i=0, j=0, prev_i=0;
	unsigned char value;
	unsigned char binaryFrame[48][84] = {
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,1,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1
},
{1,1,1,1,1,1,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1
},
{1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1
},
{1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,1,1,1,0,0,1,1,1,1,1,1,0,0,1,1,0,0,1,1,1,1,0,0,1,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,1,1,1,0,0,1,1,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,1,1,1,0,0,1,0,0,1,1,1,0,0,1,1,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,0,0,1,1,1,1,0,0,1,1,0,0,1,1,1,0,0,1,0,0,1,1,1,0,0,1,1,0,0,1,1,1,1,0,0,1,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,1,0,0,1,1,1,0,0,1,1,0,0,1,1,1,1,1,1,1,0,0,1,1,0,0,1,1,1,0,0,1,1,0,0,1,1,1,1,0,0,1,1,1,0,0,0,1,0,0,1,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,1,1,0,0,1,1,1,0,0,1,1,0,0,1,1,1,0,0,0,0,0,0,1,1,0,0,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,1,1,0,0,1,1,1,1,0,0,0,0,1,1,1,0,0,1,1,1,0,0,1,1,0,0,1,1,1,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,1,1,0,0,1,1,1,1,0,0,0,0,1,1,1,0,0,1,1,1,0,0,1,1,0,0,1,1,1,0,0,1,1,0,0,1,1,1,1,0,0,1,1,1,0,0,1,1,1,1,1,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
}
};

memset(framebuffer, 0, 84*6*sizeof(unsigned char));//Clear Screen
//Convert this array to framebuffer array
for(i=0; i<6; i++)
		for(j=0; j<84; j++)
			framebuffer[i][j] = 1 * binaryFrame[8*i][j] + 2 * binaryFrame[8*i+1][j] + 4 * binaryFrame[8*i+2][j] + 8* binaryFrame[8*i+3][j] 
						+ 16 * binaryFrame[8*i+4][j] + 32 * binaryFrame[8*i+5][j] + 64 * binaryFrame[8*i+6][j] + 128 * binaryFrame[8*i+7][j];
delayMS(1000);
}

int main(){
	//INTERRUPT CODE Begins
	EXTMODE = 0x4;												//EINT2 is edge sensitive
	EXTPOLAR &= ~(0x4);										//EINT2 is falling edge sensitive
	PINSEL0 |= 0x80000000; 
	//Interrupt Configuration
	VICIntSelect &= ~(1<<16);        		// EINT2 selected as IRQ 16
	VICVectAddr5  = (unsigned int)Ext_ISR_Pre;// Button Press starts game
	VICVectCntl5  = (1<<5) | 16;					// Configure EINT2
	VICIntEnable |= (1<<16);           		// EINT2 interrupt enabled
	EXTINT 			 &= ~(0x4);							  //Clear all other interrupts
	
	
	//Hardware Initialization
	PCD8544_init();
	//testHW();

	lcd_putstring(0, "Welcome to      ");
	lcd_putstring(1, "Space Invaders! ");
	delayMS(3000);
	lcd_putstring(0, "Press to play   ");
	
			//set up interrupts for the timer0
	VICIntSelect &= ~(1<<4);
	VICVectAddr4 = (unsigned int)Timer_ISR;
	VICVectCntl4 = (1<<5) | 4;
	VICIntEnable |= (1<<4);
	//Interrupt Code ENDS

	//TODO
	//Random Bank movement	DONE
	//Faster cursor					DONE
	//Arrow Fire Animation
	//Border correction			
	
	//Set cursor
	cursor=0;
	while(1)
		bow_movement();
	return 0;	
}

void testHW(){
	//EEPROM TESTING CODE
	//Read value in EEPROM
	m24xx_read(EEPROM_24XX256, 0 , 0 ,(char*)read_buffer , sizeof(read_buffer));	// Type, Starting address,Hardware Values A2,A1,A0 ,Data dst buf,Bytes to read qty
	//Print value to LCD
	sprintf((char *)lcdbuffer1, "High Score: %c", read_buffer[0]);
	lcd_putstring(1,(char *)lcdbuffer1);
	
	//Buzzer Testing Code
	IO1DIR |= (1<<25);	//Enable Buzzer
	IO1CLR |= (1<<25); 	//Start Buzzer
	delayMS(1000);		//Delay period
  IO1SET |= (1<<25); 	//Stop Buzzer
	
}
